'use strict';Object.defineProperty(exports,"__esModule",{value:true});exports.fileUploadingMiddleware=exports.graphqlCMS=exports.fixPath=exports.isListOfType=exports.hasNestedFields=exports.resolveInputControl=exports.resolveInputType=exports.getFields=exports.getTypeListData=exports.getListHeader=exports.checkMethodPermission=exports.findResolverArgs=exports.getResolverName=exports.applyRules=undefined;var _typeof=typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"?function(obj){return typeof obj;}:function(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj;};var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};exports.default=function(config){var _this=this;var schema=config.schema?(0,_graphql.parse)(config.schema):false;if(!schema){throw new Error('you have to provide your PRINTED schema in config object "{schema: myPrintedSchema}"');}var rules=config.rules?config.rules:false;var exclude=config.exclude?config.exclude:false;var uploadRoot=config.uploadRoot?fixPath(config.uploadRoot):false;return function(req,res){if(req.method.toLowerCase()==='get'){res.send(applyRules({rules:rules,shape:graphqlCMS({schema:schema,rules:rules,exclude:exclude,uploadRoot:uploadRoot})}));}else if(req.method.toLowerCase()==='post'){fileUploadingMiddleware.call(_this,req,res,uploadRoot);}};};var _formidable=require('formidable');var _formidable2=_interopRequireDefault(_formidable);var _fsExtra=require('fs-extra');var _fsExtra2=_interopRequireDefault(_fsExtra);var _util=require('util');var _util2=_interopRequireDefault(_util);var _graphql=require('graphql');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}var applyRules=function funcApplyRules(args){var shape=args.shape,rules=args.rules;var response=rules?_extends({},rules):_extends({},shape);if(rules){Object.keys(shape).forEach(function(key){if(_typeof(shape[key])==='object'){if(!response[key]){response[key]=shape[key];}else{response[key]=applyRules({shape:shape[key],rules:response[key]});}}else if(!response[key]&&typeof response[key]!=='boolean'){response[key]=shape[key];}});}Object.keys(response).forEach(function(key){if(key==='resolvers'){Object.keys(response[key]).forEach(function(resolver){if(typeof response[key][resolver].allowed==='boolean'&&!response[key][resolver].allowed){delete response[key][resolver];}});}});return response;};var getResolverName=function funcGetResolverName(args){var typeName=args.typeName,method=args.method,rules=args.rules;var resolverName='';if(rules&&rules[typeName]&&rules[typeName].resolvers&&rules[typeName].resolvers[method]&&rules[typeName].resolvers[method].resolver){resolverName=rules[typeName].resolvers[method].resolver;}else{resolverName=typeName+'_'+method;}return resolverName;};var findResolverArgs=function funcFindResolverArgs(args){var typeName=args.typeName,method=args.method,fields=args.fields,rules=args.rules;var respond={};var tmpObj={};if(rules&&rules[typeName]&&rules[typeName].resolvers&&rules[typeName].resolvers[method]&&rules[typeName].resolvers[method].resolver){tmpObj=fields.find(function(obj){return obj.name.value===rules[typeName].resolvers[method].resolver;});}else{tmpObj=fields.find(function(obj){return obj.name.value===typeName+'_'+method;});}if(tmpObj&&tmpObj.arguments){tmpObj.arguments.forEach(function(argObj){respond[argObj.name.value]=argObj.type.kind==='NonNullType'?argObj.type.type.name.value+'!':argObj.type.name.value;});}return respond;};var checkMethodPermission=function funcCheckMethodPermission(args){var typeName=args.typeName,method=args.method,mutations=args.mutations,rules=args.rules;var hasMethod=!!mutations.fields.find(function(obj){return obj.name.value===typeName+'_'+method;});if(rules&&hasMethod&&rules[typeName]&&rules[typeName].resolvers&&rules[typeName].resolvers[method]&&(rules[typeName].resolvers[method].allowed||typeof rules[typeName].resolvers[method].allowed==='boolean')){hasMethod=rules[typeName].resolvers[method].allowed;}return hasMethod;};var getListHeader=function funcGetListHeader(args){var shape=args.shape;var response=_extends({},shape);var id=void 0;var title=void 0;Object.keys(response).forEach(function(key){id=Object.keys(response[key].fields).find(function(i){return i==='id'||i==='_id';});title=Object.keys(response[key].fields)[1];response[key].listHeader={id:[id],title:[title]};});return response;};var getTypeListData=function funcGetTypeListData(args){var schema=args.schema,typeName=args.typeName,rules=args.rules;var Queries=schema.definitions.find(function(obj){return obj.name.value==='Query';});var Mutations=schema.definitions.find(function(obj){return obj.name.value==='Mutation';});return{propTypeName:typeName,label:false,resolvers:{find:{resolver:getResolverName({rules:rules,typeName:typeName,method:'find'}),args:findResolverArgs({rules:rules,typeName:typeName,method:'find',fields:Queries.fields})},create:{resolver:getResolverName({rules:rules,typeName:typeName,method:'create'}),args:findResolverArgs({rules:rules,typeName:typeName,method:'create',fields:Mutations.fields})}}};};var hasNestedFields=function funcHasNestedFields(propType){switch(propType.toLowerCase()){case'boolean':return false;case'string':return false;case'int':return false;case'float':return false;case'number':return false;default:return true;}};var isListOfType=function funcIsListOfType(typeValue){switch(typeValue){case'Int':return false;case'Float':return false;case'Boolean':return false;case'String':return false;default:return true;}};var resolveInputType=function funcResolveInputType(scalarType){switch(scalarType||scalarType.slice(0,-1)){case'Int':return'number';case'Float':return'number';case'Boolean':return'checkbox';case'String':return'text';default:return'text';}};var resolveInputControl=function funcResolveInputControl(scalarType){switch(scalarType||scalarType.slice(0,-1)){case'Int':return'input';case'Float':return'input';case'Boolean':return'input';case'String':return'input';default:return'input';}};var getFields=function funcGetFields(args){var schema=args.schema,typeName=args.typeName,rules=args.rules;var typeObject=schema.definitions.find(function(obj){return obj.name.value===typeName;});var result={};typeObject.fields.forEach(function(prop){if(prop&&prop.type&&prop.type.kind!=='ListType'){if(prop.name&&prop.name.value&&prop.type.name&&prop.type.name.value&&prop.name.value!=='Mutation'&&prop.name.value!=='Query'){var has=hasNestedFields(prop.type.name.value);result[prop.name.value]={label:prop.name.value,fieldType:prop.type.name.value,inputType:has?'String':resolveInputType(prop.type.name.value),inputControl:resolveInputControl(prop.type.name.value),disabled:false,exclude:false,list:false,nestedFields:has?getFields({schema:schema,rules:rules,typeName:prop.type.name.value}):false};}}else if(prop&&prop.type&&prop.type.type&&prop.type.type.name&&prop.type.type.name.value&&isListOfType(prop.type.type.name.value)&&prop.name.value!=='Mutation'&&prop.name.value!=='Query'){result[prop.name.value]={label:prop.name.value,fieldType:prop.type.type.name.value,inputType:false,inputControl:'selection',disabled:false,exclude:false,list:getTypeListData({schema:schema,rules:rules,typeName:prop.type.type.name.value}),nestedFields:getFields({schema:schema,typeName:prop.type.type.name.value})};}});return result;};var fixPath=function funcFixPath(string){var response='';if(string.slice(0,1)==='/'||string.slice(0,1)==='.'){response=string;}else{response='/'+string;}if(response.slice(-1)==='/'){response=response.slice(0,-1);}return response;};var graphqlCMS=function funcGraphqlCMS(args){var schema=args.schema,rules=args.rules,exclude=args.exclude,uploadRoot=args.uploadRoot;var Mutations=schema.definitions.find(function(obj){return obj.name.value==='Mutation';});var Queries=schema.definitions.find(function(obj){return obj.name.value==='Query';});var shape={};Queries.fields.forEach(function(method){var methodTypeName=method.type&&method.type.type&&method.type.type.name&&method.type.type.name.value?method.type.type.name.value:false;if(methodTypeName&&Mutations.fields.find(function(obj){return obj.name.value.split('_')[0]===methodTypeName;})&&(!exclude||!exclude.find(function(type){return type===methodTypeName;}))){shape[methodTypeName]={uploadRoot:uploadRoot,label:methodTypeName,listHeader:false,resolvers:{find:{resolver:getResolverName({rules:rules,typeName:methodTypeName,method:'find'}),args:findResolverArgs({rules:rules,typeName:methodTypeName,method:'find',fields:Queries.fields}),allowed:true},create:{resolver:getResolverName({rules:rules,typeName:methodTypeName,method:'create'}),args:findResolverArgs({rules:rules,typeName:methodTypeName,method:'create',fields:Mutations.fields}),allowed:checkMethodPermission({rules:rules,typeName:methodTypeName,method:'create',mutations:Mutations})},update:{resolver:getResolverName({rules:rules,typeName:methodTypeName,method:'update'}),args:findResolverArgs({rules:rules,typeName:methodTypeName,method:'update',fields:Mutations.fields}),allowed:checkMethodPermission({rules:rules,typeName:methodTypeName,method:'update',mutations:Mutations})},remove:{resolver:getResolverName({rules:rules,typeName:methodTypeName,method:'remove'}),args:findResolverArgs({rules:rules,typeName:methodTypeName,method:'remove',fields:Mutations.fields}),allowed:checkMethodPermission({rules:rules,typeName:methodTypeName,method:'remove',mutations:Mutations})}},fields:getFields({schema:schema,rules:rules,typeName:methodTypeName})};}});shape=getListHeader({shape:shape});return shape;};var fileUploadingMiddleware=function funcFileUploadingMiddleware(req,res,uploadRoot){var form=new _formidable2.default.IncomingForm();form.parse(req,function(err,fields,files){res.end(_util2.default.inspect({fields:fields,files:files}));});form.on('error',function(err){if(err)throw new Error(err);});form.on('end',function(){var tempPath=this.openedFiles[0].path;var fileName=this.openedFiles[0].name.split(',')[0];var folderPath=fixPath(this.openedFiles[0].name.split(',')[1]);_fsExtra2.default.copy(tempPath,''+uploadRoot+folderPath+'/'+fileName,function(err){if(err)throw new Error(err);});});};// export declared only for test cases
exports.applyRules=applyRules;exports.getResolverName=getResolverName;exports.findResolverArgs=findResolverArgs;exports.checkMethodPermission=checkMethodPermission;exports.getListHeader=getListHeader;exports.getTypeListData=getTypeListData;exports.getFields=getFields;exports.resolveInputType=resolveInputType;exports.resolveInputControl=resolveInputControl;exports.hasNestedFields=hasNestedFields;exports.isListOfType=isListOfType;exports.fixPath=fixPath;exports.graphqlCMS=graphqlCMS;exports.fileUploadingMiddleware=fileUploadingMiddleware;